document.addEventListener("DOMContentLoaded", function () {

  initCssEditorDom()
 
});

function initCssEditorDom(){

   // 获取body元素
   var body = document.body;

   // 创建一个新的元素
   var newElement = document.createElement("div");
 
   newElement.innerHTML = initCssEditor();
 
   // 将新元素添加到body元素的末尾
   body.appendChild(newElement);
 
   // 弹窗层
   const cssEditorModal = document.getElementById("css-editor-modal");
 
   // 为外部 div 添加点击事件监听器
   cssEditorModal.addEventListener("click", function (event) {
     if (event.target === cssEditorModal) {
      //  cssEditorModal.style.display = "none";
      cssEditorModal.remove();
 
 
     } else {
       // 阻止事件冒泡
       event.stopPropagation();
     }
   });

}

function initCssEditor() {
  return `
    <div class="css-editor-modal" id="css-editor-modal">
      <div class="css-editor-modal-content">
          <div class="css-editor-modal-content-top">
            <iframe id="css_modal_csseditor" src="https://www.csseditor.cn/editor/" width="98%" height="100%" style="border:1px solid #EEEEEE;"></iframe>
          </div>

          <div class="css-editor-modal-content-buttons"> 
            <button type="button" class="" style="margin-right: 20px;" onclick="setCssCancel()">取消</button>
            <button type="button" class=""  onclick="setCssDetermine()"   >确定</button>
          </div>
      

      </div>
    </div>`;
}

// 取消
function setCssCancel() {

  // document.querySelector(".css-editor-modal").style.display = "none";

  document.getElementById("css-editor-modal").remove();

}


// 移除style (已取消)
// function setStyleState(){

//   var sClass = document.getElementsByClassName('css-editor-modal-content')[0];
//   sClass.removeAttribute("style");

// }

// 确定按钮的事件  关闭弹窗 回传
function setCssDetermine() {
  if (sCssStatus == 1 && typeof fFun == "function") {
    fFun(sCssDialogValue);
  }
  setCssCancel();
}

// 存弹窗css编辑的值
var sCssDialogValue = "";

// 弹窗有设置值时 更改状态为1
var sCssStatus = 0;

// 回调的方法
var fFun;

// 打开弹窗
function setCssDialog(data, fun, config = {}) {
  initCssEditorDom()
  fFun = fun;
  const sCssdialogIframe = document.getElementById("css_modal_csseditor");

  sCssDialogValue = "";
  sCssStatus = 0;

  let oObj = {
    style: data,
  };

  sCssdialogIframe.contentWindow.postMessage(oObj, "*");

  window.addEventListener(
    "message",
    (event) => {
      if (event.data.style != undefined && event.data.style != null) {
        sCssStatus = 1;
        sCssDialogValue = event.data.style;
      }
    },
    false
  );

  // $('.css-editor-modal').show();

  // 设置弹窗的大小 
  if (config && typeof config == 'object') {

    if (Object.keys(config)) {



      var sClass = document.getElementsByClassName('css-editor-modal-content')[0];

      let sWidth = config.width
      if (sWidth != '' && sWidth !=undefined  && sWidth != null) {
        if (Number(sWidth).toString() != "NaN") {
          sWidth = sWidth + "px";
        }
        sClass.style.width = sWidth;
        sClass.style.maxWidth = sWidth;
      }
      let sHeight = config.height
      if (sHeight != '' && sHeight !=undefined  && sHeight != null) {
        if (Number(sHeight).toString() != "NaN") {
          sHeight = sHeight + "px";
        }
        sClass.style.height = sHeight;
        sClass.style.maxHeight = sHeight;
      }
    }
  }


  // 打开弹窗 

  document.querySelector(".css-editor-modal").style.display = "block";

}



function openCssEditor(id, config = {}, fun = function () { }) {
  if (!id) {
    return alert("openCssEditor方法没有传入ID");
  }

  if (typeof id != "string") {
    return alert("ID需为字符串格式 ");
  }

  let oInputElement = document.getElementById(id);



  let sInputValue = oInputElement.value ;


  setCssDialog(sInputValue, (event) => {
    oInputElement.value = event;

    if (typeof fun == 'function') {
      fun(event)
    }

  },config);
}
